<?php

/**
 * @file
 * Helper functions for codes module.
 */

/**
 * Set subsets for given code.
 */
function codes_set_subsets($coid, $value) {
  $serialized_value = serialize($value);
  db_query("UPDATE {code} SET subset = '%s' WHERE coid = %d", $serialized_value, $coid);
}

/**
 * Get subsets of given code.
 */
function codes_get_subsets($coid) {
  $code = db_fetch_object(db_query("SELECT subset FROM {code} WHERE coid = %d", $coid));
  if (isset($code->subset)) {
    return unserialize($code->subset);
  }
  else {
    return array();
  }
}

/**
 * Set subset values.
 */
function codes_set_subset($coid, $subset_name, $options, $default, $description = NULL) {
  $subsets = codes_get_subsets($coid);
  $subsets[$subset_name]['options'] = $options;
  $subsets[$subset_name]['default'] = $default;
  if (isset($description)) {
    $subsets[$subset_name]['description'] = $description;
  }
  codes_set_subsets($coid, $subsets);
}

/**
 * Get subset values.
 */
function codes_get_subset($coid, $subset_name) {
  $subsets = codes_get_subsets($coid);
  if (isset($subsets[$subset_name])) {
    return $subsets[$subset_name];
  }
  else {
    return array();
  }
}

/**
 * Delete subset.
 */
function codes_del_subset($coid, $subset_name) {
  $subsets = codes_get_subsets($coid);
  if (isset($subsets[$subset_name])) {
    unset($subsets[$subset_name]);
  }
  codes_set_subsets($coid, $subsets);
}

